"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _classnames = _interopRequireDefault(require("classnames"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _InputWrapper = _interopRequireDefault(require("../../components/InputWrapper"));

const Multiselect = (_ref) => {
  let errors = _ref.errors,
      fieldData = _ref.fieldData,
      name = _ref.name,
      register = _ref.register,
      wrapProps = (0, _objectWithoutPropertiesLoose2.default)(_ref, ["errors", "fieldData", "name", "register"]);
  const choices = fieldData.choices,
        cssClass = fieldData.cssClass,
        id = fieldData.id,
        isRequired = fieldData.isRequired,
        size = fieldData.size;
  const options = JSON.parse(choices);
  return _react.default.createElement(_InputWrapper.default, (0, _extends2.default)({
    errors: errors,
    inputData: fieldData,
    labelFor: name
  }, wrapProps), _react.default.createElement("select", {
    //TODO: GF uses select2 library and classes, need to figure out how to handle here if we're mimicing their functionality
    className: (0, _classnames.default)('gravityform__field__input__select', 'gfield_select', cssClass, size),
    id: name,
    multiple: true,
    name: name,
    ref: register({
      required: isRequired
    })
  }, options.map(({
    isSelected,
    text,
    value
  }, index) => {
    return _react.default.createElement("option", {
      defaultValue: isSelected,
      key: `${id}_${index}`,
      value: value
    }, text);
  })));
};

var _default = Multiselect;
exports.default = _default;
Multiselect.propTypes = {
  errors: _propTypes.default.object,
  fieldData: _propTypes.default.shape({
    cssClass: _propTypes.default.string,
    id: _propTypes.default.number,
    choices: _propTypes.default.string,
    size: _propTypes.default.string,
    isRequired: _propTypes.default.bool
  }),
  name: _propTypes.default.string,
  register: _propTypes.default.func,
  wrapProps: _propTypes.default.object
};